// ConsoleApplication411.cpp:      .
//

// ConsoleApplication397.cpp:      .
//

#include "stdafx.h"
#include<iostream>
#include<cmath>
#include<clocale>
#include <cstdlib>
#include<fstream>
enum ErstenNach { A, B, C }; //   (c. )
using namespace std;

struct Point // 
{
	double x; // 
	double y; // 
};

class Ballistics
{
private:
	const double pi = 3.14159265358979;
	const double g = 9.8;//  (  )(/c^2)
	double dt = 0.1;//  ()

public:

	double n;
	double m;
	void bewegungimVakuum(double x0, double y0, double v0, double a, Point *mass);//,     x  y   
	void lineareWiederstands(double x0, double y0, double v0, double a, double n, double m, Point *mass);//,     x  y   
	void quadratischeWiederstands(double x0, double y0, double v0, double a, double n, double m, Point *mass);//,     x  y   

																											  //x0,y0- ;
																											  //v0- 
																											  //a -   
																											  //n -   
																											  //m -  
																											  //mass -  ()

};




void Ballistics::bewegungimVakuum(double x0, double y0, double v0, double a, Point *mass)//  
{   //(x0,y0)- 
	//  v0- 
	//  a-  
	//   mass- 
	//   *mass-   


	double t = 0;

	for (int i = 0; i < 15; i++) //15  
	{

		mass[i].x = x0 + v0*cos(a*pi / 180.0)*t;
		mass[i].y = y0 + v0*sin(a*pi / 180.0)*t - (g*t*t / 2);
		t += (2 * v0*sin(a*pi / 180.0)) / (g * 14); //  


	}
}
void Ballistics::lineareWiederstands(double x0, double y0, double v0, double a, double n, double m, Point *mass)//  
{
	//(x0,y0)- 
	//  v0- 
	//  a-  
	//  n -  
	//  m -  
	//   mass- 
	//   *mass-   



	double t = 0;

	for (int i = 0; i < 25; i++) //25  

	{
		t += dt;
		mass[i].x = x0 + v0*cos(a*pi / 180.0)*(1 - exp(-n*t / m))*m / n;
		mass[i].y = y0 + ((v0*sin(a*pi / 180.0) + m*g / n)*(1 - exp(-n*t / m)) - g*t)*m / n;
	}

}

void Ballistics::quadratischeWiederstands(double x0, double y0, double v0, double a, double n, double m, Point *mass)// 
{
	//   ,   - 
	//m(d ^ (2)x / dt ^ 2) = F
		//(x0,y0)- 
		//  v0- 
		//  a-  
		//  n -  
		//  m -  
		//   mass- 
		//   *mass-   

		mass[1].x = x0;
	mass[1].y = y0;
	mass[0].x = mass[1].x - v0*cos(a*pi / 180.0)*dt;
	mass[0].y = mass[1].y - v0*sin(a*pi / 180.0)*dt;
	mass[2].x = mass[1].x + v0*cos(a*pi / 180.0)*dt;
	mass[2].y = mass[1].y + v0*sin(a*pi / 180.0)*dt;

	double Fx = n*v0*v0*cos(a*pi / 180.0);
	double Fy = m*g + n*v0*v0*sin(a*pi / 180.0);



	for (int i = 3; i < 18; i++) //   ,  3  18 -   
	{




		mass[i].x = 2 * mass[i - 1].x - mass[i - 2].x - (Fx / m)*dt*dt;
		mass[i].y = 2 * mass[i - 1].y - mass[i - 2].y - (Fy / m)*dt*dt;

		double vx = (mass[i].x - mass[i - 2].x) / (2 * dt);
		double vy = (mass[i].y - mass[i - 2].y) / (2 * dt);


		Fx = n*vx*v0;
		Fy = m*g + n*vy*v0;


	}

}

int main()
{
	setlocale(LC_ALL, "Russian");
	double x0, y0, v0, a, n, m;
	ErstenNach L;



	for (;;)// 

	{
		ifstream fin;
		fin.open("Heartstone.txt");
		ofstream fout("Heartstone.txt");//   


		system("cls");
		cout << "      Heartstone\n";
		cout << "     ,    :" << "\n";
		cin >> x0;
		cin >> y0;
		cin >> v0;
		cin >> a;


		int answer;
		cout << "  :" << "\n";
		cout << "0 -   \n"
			<< "1 -   \n"
			<< "2 -   \n";// 

		cin >> answer;
		switch (answer)
		{
		case 0: L = A; break;
		case 1: L = B; break;
		case 2: L = C; break;
		default:
			cout << "ERROR" << "\n";
			system("pause");
			continue;
		}

		// 
		if (L == A)
		{
			Point mass[15];// 15 

			for (int i = 0; i < 15; i++)
			{
				Ballistics x, y;

				x.bewegungimVakuum(x0, y0, v0, a, mass); //  
					y.bewegungimVakuum(x0, y0, v0, a, mass);


				fout << mass[i].x << "  " << mass[i].y << "\n";

			}


		}
		if (L == B)
		{

			cout << "      \n";
			cin >> n;
			cin >> m;
			Point mass[25];// 25 


			for (int i = 0; i < 25; i++)
			{
				Ballistics x, y;
				x.lineareWiederstands(x0, y0, v0, a, n, m, mass); //  
					y.lineareWiederstands(x0, y0, v0, a, n, m, mass);
				fout << mass[i].x << "  " << mass[i].y << "\n";


			}

		}

		if (L == C)
		{

			cout << "      \n";
			cin >> n;
			cin >> m;

			Point mass[18];// 18 

			for (int i = 1; i < 18; i++)
			{
				Ballistics x, y;
				x.quadratischeWiederstands(x0, y0, v0, a, n, m, mass); //  
					y.quadratischeWiederstands(x0, y0, v0, a, n, m, mass);
				fout << mass[i].x << "  " << mass[i].y << "\n";



			}

		}

		fout.close();// 

		system("pause");
	}


	return 0;
}




